package nova.monadic_sfx.ui

import nova.monadic_sfx.util.controls.JFXSpinner
import scalafx.geometry.Insets
import scalafx.geometry.Pos
import scalafx.scene.Scene
import scalafx.scene.effect.DropShadow
import scalafx.scene.layout.HBox
import scalafx.scene.layout.VBox
import scalafx.scene.paint.Color._
import scalafx.scene.paint._
import scalafx.scene.text.Text

object DefaultUI {
  val scene =
    new Scene {
      fill = Color.rgb(38, 38, 38)
      content = new VBox {
        alignment = Pos.Center
        padding = Insets(50, 80, 50, 80)
        children = Seq(
          new HBox {
            padding = Insets(50, 80, 50, 80)
            children = Seq(
              new Text {
                text = "Scala"
                style = "-fx-font: normal bold 100pt sans-serif"
                fill = new LinearGradient(endX = 0, stops = Stops(Red, DarkRed))
              },
              new Text {
                text = "FX"
                style = "-fx-font: italic bold 100pt sans-serif"
                fill = new LinearGradient(
                  endX = 0,
                  stops = Stops(White, DarkGray)
                )
                effect = new DropShadow {
                  color = DarkGray
                  radius = 15
                  spread = 0.25
                }
              }
            )
          },
          new JFXSpinner {
            radius = 50
            // style = "-fx-text-fill: red"
          }
        )
      }
    }
}
